<?php

/* --------------------------------------------------------------
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2011 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class CategoriesStructGenerator {

    var $centralDB = false;
    var $source_categories_id = 0;
    var $source_language_id = 0;
    var $include_categories_description = true;
    var $esHelper = false;

    function __construct($centralDB) {
        $this->centralDB = $centralDB;
        $this->esHelper = new EntityStructHelper($this->centralDB);
    }

    function get_full_struct($source_categories_id, $source_language_id = 0) {
        $this->source_categories_id = $source_categories_id;
        $this->source_language_id = $source_language_id;
        $struct_category = $this->esHelper->create_entity_struct('categories', 'categories_id', $this->source_categories_id);
        //DESCRIPTION
        if ($this->include_categories_description) {
            $pack = $this->get_pack_categories_description($this->source_categories_id);
            $struct_category->add_struct_pack($pack);
        }
        return $struct_category;
    }

    function get_pack_categories_description($categories_id) {
        $output_pack = array();
        $sec_key_name = '';
        $sec_key_value = '';
        $sql = '
			SELECT 
				categories_id,
				language_id
			FROM 	categories_description
			WHERE categories_id = "' . $categories_id . '"
		';
        if ($this->source_language_id > 0) {
            $sql .= ' AND language_id = "' . $this->source_language_id . '" ';
            $sec_key_name = 'language_id';
            $sec_key_value = $this->source_language_id;
        }
        $result = $this->centralDB->query($sql);
        while (($row = mysqli_fetch_array($result))) {
            $output_pack[] = $this->esHelper->create_entity_struct('categories_description', 'categories_id', $row['categories_id'], $sec_key_name, $sec_key_value);
        }
        return $output_pack;
    }
}
