<?php

/* --------------------------------------------------------------
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2011 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class FeatureStructGenerator {

    var $centralDB = false;
    var $source_feature_id = 0;
    var $source_language_id = 0;
    var $include_feature_name = true;
    var $esHelper = false;

    function __construct($centralDB) {
        $this->centralDB = $centralDB;
        $this->esHelper = new EntityStructHelper($this->centralDB);
    }

    function get_full_struct($source_feature_id, $source_language_id = 0) {
        $this->source_feature_id = $source_feature_id;
        $this->source_language_id = $source_language_id;
        $struct_feature = $this->esHelper->create_entity_struct('feature', 'feature_id', $this->source_feature_id);
        if ($this->include_feature_name) {
            $pack = $this->get_pack_feature_name($this->source_feature_id);
            $struct_feature->add_struct_pack($pack);
        }
        return $struct_feature;
    }

    function get_pack_feature_name($feature_id) {
        $output_pack = array();
        $sql = '
			SELECT 
				feature_name_id
			FROM 	feature_name
			WHERE feature_id = "' . $feature_id . '"
		';

        if ($this->source_language_id > 0) {
            $sql .= ' AND language_id = "' . $this->source_language_id . '" ';
        }
        $result = $this->centralDB->query($sql);
        while (($row = mysqli_fetch_array($result))) {
            $output_pack[] = $this->esHelper->create_entity_struct('feature_name', 'feature_name_id', $row['feature_name_id']);
        }
        return $output_pack;
    }
}
